!MAIN
!use dflib
integer, parameter :: levmax=600
integer, parameter :: gammax=1200
integer, parameter :: brmax=30
character symb*5,jpestimate_lev(levmax)*1,uncertaint_lev(levmax)*4,jptext_lev(levmax)*18
character pfix_lev(levmax,brmax)*2,dmodes_lev(levmax,brmax)*7,impos*1
character fname*100,mult_gam(gammax)*10
integer A,Z,nlev,ngam,nmax,nc,m,i,k,j,n,nog_lev(levmax),nobr_lev(levmax)
integer initial_gam(gammax),final_gam(gammax),w,jj,noofhit
logical both,hasQ,even
real*4 sn,sp,e_gam(gammax),ri_gam(gammax),ri1_gam(gammax),cc_gam(gammax),sum,diff,eg,si,sf,pi,pf,ritot,br(brmax)
real*4 e_lev(levmax),jsmy_lev(levmax),jpmy_lev(levmax),t_lev(levmax),dpercent_lev(levmax,brmax)
real*4 ll1,l1,IT_percent,RIsum,TOTsum
real*8 mixr_gam(gammax),prob_gam(gammax)
real*8 egd,dmix,icc
character*10 strmul,text
logical firstentry,data_exists
!COMMON declaration
common /inp/ symb,jpestimate_lev,uncertaint_lev,jptext_lev, &
pfix_lev,dmodes_lev,impos, &
fname,mult_gam, &
A,Z,nlev,ngam,nmax,nc,m,i,k,j,n,nog_lev,nobr_lev, &
initial_gam,final_gam,w,jj, &
both,hasQ,even, &
sn,sp,e_gam,ri_gam,ri1_gam,cc_gam,sum,diff,eg,si,sf,pi,pf,ritot,br, &
e_lev,jsmy_lev,jpmy_lev,t_lev,dpercent_lev, &
ll1,l1,IT_percent,RIsum,TOTsum, &
mixr_gam,prob_gam, &
egd,dmix,icc, &
strmul,text
!End of COMMON declaration
!Generate all z & a & call getza subroutine
!The getza routine provide a logical flag. If data exists it is true else it is false
noofhit=0
do z=0,109
do a=1,266
call getza(data_exists)
if(data_exists) then
 write(*,*) z,a,data_exists
 noofhit=noofhit+1
endif
enddo
enddo
write(*,*) 'The total number of nuclear data sets is ',noofhit
write(*,*) 'Hit return to finish!'
read(*,*)
stop
end
!**************************************************************************************
subroutine 	getza(data_exists)
integer, parameter :: levmax=600
integer, parameter :: gammax=1200
integer, parameter :: brmax=30
character symb*5,jpestimate_lev(levmax)*1,uncertaint_lev(levmax)*4,jptext_lev(levmax)*18
character pfix_lev(levmax,brmax)*2,dmodes_lev(levmax,brmax)*7,impos*1
character fname*100,mult_gam(gammax)*10
integer A,Z,nlev,ngam,nmax,nc,m,i,k,j,n,nog_lev(levmax),nobr_lev(levmax)
integer initial_gam(gammax),final_gam(gammax),w,jj
logical both,hasQ,even
real*4 sn,sp,e_gam(gammax),ri_gam(gammax),ri1_gam(gammax),cc_gam(gammax),sum,diff,eg,si,sf,pi,pf,ritot,br(brmax)
real*4 e_lev(levmax),jsmy_lev(levmax),jpmy_lev(levmax),t_lev(levmax),dpercent_lev(levmax,brmax)
real*4 ll1,l1,IT_percent,RIsum,TOTsum
real*8 mixr_gam(gammax),prob_gam(gammax)
real*8 egd,dmix,icc
character*10 strmul,text
logical firstentry,data_exists
integer AA,ZZ
!COMMON declaration
common /inp/ symb,jpestimate_lev,uncertaint_lev,jptext_lev, &
pfix_lev,dmodes_lev,impos, &
fname,mult_gam, &
A,Z,nlev,ngam,nmax,nc,m,i,k,j,n,nog_lev,nobr_lev, &
initial_gam,final_gam,w,jj, &
both,hasQ,even, &
sn,sp,e_gam,ri_gam,ri1_gam,cc_gam,sum,diff,eg,si,sf,pi,pf,ritot,br, &
e_lev,jsmy_lev,jpmy_lev,t_lev,dpercent_lev, &
ll1,l1,IT_percent,RIsum,TOTsum, &
mixr_gam,prob_gam, &
egd,dmix,icc, &
strmul,text
!End of COMMON declaration
data_exists=.false.
!Check if data request is in range
if(z.lt.0.or.z.gt.109) then
write(*,*) 'Data with this charge number Z does not exists Z=',z
return
endif
if(a.lt.1.or.a.gt.266) then
write(*,*) 'Data with this mass number A does not exists A=',a
return
endif
!open file with the give Z
if(z.lt.10) write(fname,'(a4,i1,a4)') 'Z00',Z,'.dat'
if(z.lt.100.and.z.ge.10) write(fname,'(a3,i2,a4)') 'Z0',Z,'.dat'
if(z.gt.99) write(fname,'(a2,i3,a4)') 'Z',Z,'.dat'
!write(fname,'(a2,i3.0,a4)') 'Z',Z,'.dat'
open(2,file=fname,status='old')
1 read(2,'(a5,6i5,2f12.6)',end=999) &
		symb, &
		AA, &
		ZZ, &
		nlev, &
		ngam, &
		nmax, &
		nc, &
		sn, &
		sp
j=0;jj=0
if(a.eq.aa.and.z.eq.zz) then
data_exists=.true.
write(*,*) symb
goto 999
endif
do jj=1,nlev
	read(2,'(i3,1x,f10.6,1x,f5.1,i3,1x,(1pe10.2),i3,1x,a1,1x,a4,1x,a18,i3,10(1x,a2,1x,0pf10.4,1x,a7))') &
		i, &
		e_lev(i), &
		jsmy_lev(i), &
		w, &
		t_lev(i), &
		nog_lev(i), &
		jpestimate_lev(i), &
		uncertaint_lev(i), &
		jptext_lev(i), &
		nobr_lev(i), &
		(pfix_lev(i,m),dpercent_lev(i,m),dmodes_lev(i,m),m=1,nobr_lev(i))
		jpmy_lev(i)=w
		do k=1,nog_lev(i)
			j=j+1
			read(2,'(39x,i4,1x,f10.3,3(1x,e10.3))') &
!			initial_gam(j), &
			final_gam(j), &
			e_gam(j), &
			ri_gam(j), &
			ri1_gam(j), &
			cc_gam(j)
		enddo
enddo
goto 1

999 continue
close(2)
end
!*******************************************
logical function even(i)
integer i
real*4 x
x=i
even=.false.
if(x/2.-float(int(x/2.+.1)).lt.0.1)  even=.true.
end
