!MAIN
use dflib
integer, parameter :: levmax=600
integer, parameter :: gammax=1200
integer, parameter :: brmax=30
character symb*5,jpestimate_lev(levmax)*1,uncertaint_lev(levmax)*4,jptext_lev(levmax)*18
character pfix_lev(levmax,brmax)*2,dmodes_lev(levmax,brmax)*7,impos*1
character fname*100,mult_gam(gammax)*10
integer A,Z,nlev,ngam,nmax,nc,m,i,k,j,n,nog_lev(levmax),nobr_lev(levmax),kk
integer initial_gam(gammax),final_gam(gammax),w,jj,sumnogam,sumnolev,uspin,uspinparenthesis,gspin,nspin,cspin
integer noknownecc,nonewecc
logical both,hasQ,even
real*4 sn,sp,e_gam(gammax),ri_gam(gammax),cc_gam(gammax),sum,diff,eg,si,sf,pi,pf,ritot,br(brmax)
real*4 e_lev(levmax),jsmy_lev(levmax),jpmy_lev(levmax),t_lev(levmax),dpercent_lev(levmax,brmax)
real*4 ll1,l1,IT_percent,RIsum,TOTsum,ji,jf
real*8 mixr_gam(gammax),prob_gam(gammax)
real*8 egd,dmix,icc
character*10 strmul,text
logical firstentry
real frac
!End of declarations
sumnogam=0;sumnolev=0;uspin=0;uspinparenthesis=0;gspin=0;nspin=0;cspin=0;noknownecc=0;nonewecc=0
write(*,*) 'Select one; (1) for testing only, (2) for testing and producing output'
read(*,*) w
both=.FALSE.
if(w.eq.2) both=.TRUE. 
open(1,file='dls.dat',status='old')
open(4,file='icc_list.txt',status='unknown')
open(7,file='decay_list.txt',status='unknown')
open(11,file='Nolevels_error.txt',status='unknown')
open(12,file='Decyprob_error.txt',status='unknown')
open(13,file='Energydiff_error.txt',status='unknown')
open(14,file='Trasitrate_error.txt',status='unknown')
open(15,file='NoECC_error.txt',status='unknown')
open(16,file='ICCcalc_error.txt',status='unknown')
open(17,file='MULTPOL_error.txt',status='unknown')
open(18,file='Statistics.txt',status='unknown')
open(19,file='Spin_error.txt',status='unknown')
open(20,file='Gamma_branching_error.txt',status='unknown')

1 read(1,'(a5,6i5,2f12.3)',err=2) &
		symb, &
		A, &
		Z, &
		nlev, &
		ngam, &
		nmax, &
		nc, &
		sn, &
		sp
j=0;n=0;firstentry=.true.
write(*,*) symb
sumnolev=sumnolev+nlev
do i=1,nlev
	read(1,'(i3,1x,e12.5,1x,f5.1,f4.0,1x,e10.3,i3,1x,a1,1x,a4,1x,a18,i3,10(1x,a2,1x,e9.2,1x,a7))') &
		n, &
		e_lev(i), &
		jsmy_lev(i), &
		jpmy_lev(i), &
		t_lev(i), &
		nog_lev(i), &
		jpestimate_lev(i), &
		uncertaint_lev(i), &
		jptext_lev(i), &
		nobr_lev(i), &
		(pfix_lev(i,m),dpercent_lev(i,m),dmodes_lev(i,m),m=1,nobr_lev(i))
		sumnogam=sumnogam+nog_lev(i)
		if(jpestimate_lev(i).eq.'u') uspin=uspin+1
		if(jpestimate_lev(i).eq.'u'.and.scan(jptext_lev(i),'(').ne.0) then
		uspinparenthesis=uspinparenthesis+1
		endif
		if(jpestimate_lev(i).eq.'g') gspin=gspin+1
		if(jpestimate_lev(i).eq.'n') nspin=nspin+1
		if(jpestimate_lev(i).eq.'c') cspin=cspin+1
		do k=1,nog_lev(i)
			j=j+1
			read(1,'(2i4,e12.5,1x,e9.2,1x,e9.2,1x,e10.3,1x,a10)') &
			initial_gam(j), &
			final_gam(j), &
			e_gam(j), &
			ri_gam(j), &
			cc_gam(j), &
			mixr_gam(j), &
			mult_gam(j)
enddo
enddo
read(1,*)
!TESTING
ngam=j
j=0
if(nlev.ne.n) then
write(11,'(a11,a5,a50)') &
'For nucleus',symb,' Number of levels is not the same as in header row'
endif
!Test of level decay probabilities
do i=1,nlev
sum=0.;hasQ=.false.
if(nobr_lev(i).gt.0) then
do m=1,nobr_lev(i)
hasQ=pfix_lev(i,m).eq.'? '
if(.not.(dmodes_lev(i,m).eq.'%B-N   '.or.dmodes_lev(i,m).eq.'%B-2N  '.or.dmodes_lev(i,m).eq.'%B+P   ')) then
sum=sum+dpercent_lev(i,m)
endif
enddo
if(abs(sum-100.0).gt.0.1) then
	if(.not.hasQ) then
	write(12,'(a11,a5,a49,f6.2,a8,i4)') &
	'For nucleus',symb,' The summ of decay probabilities is not 100% sum=',sum,' levnum=',i
	endif
endif
endif
!Test of spins vs gamma multipolarities and energy diff.
diff=0.
ritot=0.0
call reduce(A,symb)
	do k=1,nog_lev(i)
	j=j+1
	eg=e_gam(j)
		diff=abs(e_lev(i)-eg-e_lev(final_gam(j))-eg**2/(2.*A*938000))
		if(diff.gt.5.) then	
		write(13,'(a11,a5,a50,f10.3,a4,a4,f10.3,a4,a4,f10.3,a6,f10.3)') &
		'For nucleus',symb,' The gamma energy does not fit the energy diff ei=',e_lev(i),uncertaint_lev(i),' ef=',e_lev(final_gam(j)),uncertaint_lev(final_gam(j)),' eg=',eg,' diff=',diff
		endif
	ritot=ritot+ri_gam(j)
	br(k)=ri_gam(j)
	if((jpmy_lev(i).ne.0.0).and.(jpmy_lev(final_gam(j)).ne.0.0).and.(jsmy_lev(i).gt.-0.1).and.(jsmy_lev(final_gam(j)).gt.-0.1)) then 
!If multipolarity exists in ENSDF then put here error message
		ji=jsmy_lev(i);jf=jsmy_lev(final_gam(j))
		if(jpmy_lev(i).eq.-1.0.and.jsmy_lev(i).eq.0.0) then
			ji=0.1
		elseif(jpmy_lev(final_gam(j)).eq.-1.0.and.jsmy_lev(final_gam(j)).eq.0.0)	then
			jf=0.1
		endif
		if(t_lev(i).gt.0.0) then
			call redmy(symb,e_lev(i),' ',t_lev(i)/ 0.6932,0.0,0.0,EG,ji*jpmy_lev(i),jf*jpmy_lev(final_gam(j)),0.0,0.0,0.0,BR(k)/ritot,0.0,impos)
			if(impos.eq.'2') then
				WRITE(14,'(a12,a5,a11,f10.3,a33)') &
				'For nucleus ',symb,' for level ',ELEV,' the transition rate is too large'
			endif
		endif
!Test internal conversion coefficient appears in ENSDF and add calculeted new ones
!Determine multipolarity of transition
!If both states are spin zero ie. transition is E0 do not process
		if(.not.(jsmy_lev(i).eq.0.0.and.jsmy_lev(final_gam(j)).eq.0.0)) then
		call multipol(ji*jpmy_lev(i),jf*jpmy_lev(final_gam(j)), ll1, l1)
		text=''
			if(ll1.gt.20.0) then
				write(text,'(a1,i1)') 'M',int(ll1-19.99)
			elseif(ll1.ge.10.0) then
				write(text,'(a1,i1)') 'E',int(ll1-9.99)
			endif
			strmul=trim(text)
			text=''
			if(l1.gt.20.0) then
				if(strmul(1:1).eq.'M'.or.strmul(1:1).eq.'E')	strmul=trim(strmul) // '+'
				write(text,'(a1,i1)') 'M',int(l1-19.99)
			elseif(l1.ge.10.0) then
				if(strmul(1:1).eq.'M'.or.strmul(1:1).eq.'E')	strmul=trim(strmul) // '+'
				write(text,'(a1,i1)') 'E',int(l1-9.99)
			endif
		strmul=trim(strmul) // text
!Determine mixing when no mixing ratio is available
!in case of E2+M1 strmul=M1 for odd and odd-odd nuclei
!                 strmul=E2 for even nuclei
!for higher multipolarities always the lower multipolarity will be given ie. dmix=0.0
		if(cc_gam(j).eq.0.0) then
!We do not change evaluators results
			if(.not.(even(a).and.even(z))) then
!M1 for not even nuclei
				if(strmul.eq.'E2+M1') then
				strmul='M1';dmix=0.0
					if(dmix.ne.mixr_gam(j)) then
						write(15,*) a,z,j,'mixing ratio is given, but no conversion coef is given iby evaluator, Eg=',e_gam(j)
					endif
				else
				 dmix=0.0
				endif
			else
				if(strmul.eq.'E2+M1') then
!E2 for even nuclei
				strmul='E2';dmix=10000.0
					if(dmix.ne.mixr_gam(j)) then
						write(15,*) a,z,j,'mixing ratio is given, but no conversion coef is given iby evaluator, Eg=',e_gam(j)
					endif
				else
				 dmix=10000.0
				endif
				
			endif
		
		endif
		egd=e_gam(j);dmix=mixr_gam(j)
!		write(*,*) egd
		call mixedalpha(z,egd,dmix,strmul,firstentry,icc)
			if(icc.eq.-1.0) then
				write(16,*) 'Erorr calculating ICC',symb,egd,' nlev= ',i
			endif
		firstentry=.false.
			if(cc_gam(j).ne.0.0) then
!			if(dabs(cc_gam(j)-icc)/cc_gam(j).gt.0.1) then
			noknownecc=noknownecc+1
				write(4,'(a5,1x,i4,4(1x,e11.4),2(1x,f11.4),2(1x,a10))') symb,z,e_lev(i),egd,icc,cc_gam(j),(icc-cc_gam(j))/cc_gam(j),dmix,strmul,mult_gam(j)
!			endif
			else
				cc_gam(j)=icc
				nonewecc=nonewecc+1
			endif
		endif
	endif
	enddo

enddo	

!End of TESTING
if(both) then
write(*,*) symb
!Wite Output to files vs Z (charge number)
if(z.lt.10) write(fname,'(a4,i1,a4)') 'Z00',Z,'.dat'
if(z.lt.100.and.z.ge.10) write(fname,'(a3,i2,a4)') 'Z0',Z,'.dat'
if(z.gt.99) write(fname,'(a2,i3,a4)') 'Z',Z,'.dat'
!write(fname,'(a2,i3.0,a4)') 'Z_',Z,'.dat'
open(2,file=fname,status='unknown',position='append')
write(2,'(a5,6i5,2f12.6)') &
		symb, &
		A, &
		Z, &
		nlev, &
		ngam, &
		nmax, &
		nc, &
		sn*0.001, &
		sp*0.001
j=0;jj=0
do i=1,nlev
if(nobr_lev(i).gt.0) then
write(7,'(a5,1x,i4,1x,i3,10(1x,a2,1x,f10.4,1x,a7))') &
		symb,i,nobr_lev(i), &
		(pfix_lev(i,m),dpercent_lev(i,m),dmodes_lev(i,m),m=1,nobr_lev(i))
endif
if(t_lev(i).ne.0.0) then
	write(2,'(i3,1x,f10.6,1x,f5.1,i3,1x,(1pe10.2),i3,1x,a1,1x,a4,1x,a18,i3,10(1x,a2,1x,0pf10.4,1x,a7))') &
		i, &
		e_lev(i)*0.001, &
		jsmy_lev(i), &
		int(jpmy_lev(i)), &
		t_lev(i), &
		nog_lev(i), &
		jpestimate_lev(i), &
		uncertaint_lev(i), &
		jptext_lev(i), &
		nobr_lev(i), &
		(pfix_lev(i,m),dpercent_lev(i,m),dmodes_lev(i,m),m=1,nobr_lev(i))
else
!Space for unknown half-life
	write(2,'(i3,1x,f10.6,1x,f5.1,i3,1x,10x,i3,1x,a1,1x,a4,1x,a18,i3,10(1x,a2,1x,f10.4,1x,a7))') &
		i, &
		e_lev(i)*0.001, &
		jsmy_lev(i), &
		int(jpmy_lev(i)), &
		nog_lev(i), &
		jpestimate_lev(i), &
		uncertaint_lev(i), &
		jptext_lev(i), &
		nobr_lev(i), &
		(pfix_lev(i,m),dpercent_lev(i,m),dmodes_lev(i,m),m=1,nobr_lev(i))

endif
!Test of oddness of spins
if((even(a).and.even(z)).or.(even(a).and..not.even(z))) then
if(abs(frac(jsmy_lev(i))).gt.1.0e-6.and.jsmy_lev(i).ne.-1.0) then
write(19,*) 'Spin error ',a,z,i,jsmy_lev(i)
endif
else
if(abs(frac(jsmy_lev(i))-0.5).gt.1.0e-6.and.jsmy_lev(i).ne.-1.0) then
write(19,*) 'Spin error ',a,z,i,jsmy_lev(i)
endif
endif
!Test that spin (jsmy_lev(i)) is not -1.0 below nmax
if(i.le.nmax) then
if(jsmy_lev(i).eq.-1.0) then
write(19,*) 'Spin error:spin is -1.0 below nmax',a,z,i,jsmy_lev(i)
endif
endif

		IT_percent=100.0
		do m=1,nobr_lev(i)
			do k=1,len(dmodes_lev(i,m))-2
			if(dmodes_lev(i,m)(k:k+2).eq.'%IT') IT_percent=dpercent_lev(i,m) 
			enddo
			do k=1,len(dmodes_lev(i,m))-1
			if(dmodes_lev(i,m)(k:k+1).eq.'%G') IT_percent=dpercent_lev(i,m) 
			enddo
		enddo
		RIsum=0.0;TOTsum=0.0 
		do k=1,nog_lev(i)
		jj=jj+1
!If only one gamma is given and its intensity is zero than we overwrite it to 100 (20/09/2002). 
		if(nog_lev(i).eq.1.and.ri_gam(jj).eq.0.0) ri_gam(jj)=100.
		TOTsum=TOTsum+ ri_gam(jj)*(1.0+cc_gam(jj))
		RIsum=RIsum+ ri_gam(jj)
		enddo
		if(TOTsum.eq.0.0.and.nog_lev(i).gt.0) then
		write(*,*) symb, 'Gamma brancing error of level no=',i,nog_lev(i),(ri_gam(kk),kk=jj-nog_lev(i)+1,jj)
		write(20,*) symb, 'Gamma brancing error of level no=',i,nog_lev(i),(ri_gam(kk),kk=jj-nog_lev(i)+1,jj)
!		read(*,*)
		endif
		if(TOTsum.eq.0.0) TOTsum=100.0
		do k=1,nog_lev(i)
			j=j+1
			write(2,'(39x,i4,1x,f10.3,3(1x,1pe10.3))') &
!			initial_gam(j), &
			final_gam(j), &
			e_gam(j)*0.001, &
			ri_gam(j)/TOTsum*IT_percent*0.01, &
			ri_gam(j)*(1.0+cc_gam(j))/TOTsum*IT_percent*0.01, &
			cc_gam(j)
		enddo
enddo
close(2)
endif
goto 1
2 continue
write(18,*) 'sumnolev= ',sumnolev
write(18,*) 'sumnogam= ',sumnogam
write(18,*) 'No of unique spin= ',uspin 
write(18,*) 'No of unique spin with parenthesis= ',uspinparenthesis
write(18,*) 'No of spin from gamma= ',gspin
write(18,*) 'No of spin from distribution= ',nspin
write(18,*) 'No of spin chosen from list by distribution= ',cspin
write(18,*) 'No of known ECC= ',noknownecc
write(18,*) 'No of newly determined ECC= ',nonewecc
close(1);close(4);close(7);close(11);close(12);close(13);close(14);close(15);close(16);close(17);close(18);close(19);close(20)
Write(*,*) 'End of run'
read(*,*)
end
!*******************************************
logical function even(i)
integer i
real*4 x
x=i
even=.false.
if(x/2.-float(int(x/2.+.1)).lt.0.1)  even=.true.
end
real function frac(x)
real x
frac=x-aint(x)
end
