	subroutine initcardinal(nodes,x,A,B)
      IMPLICIT REAL*8(a-H,O-Z)
	  integer nodes
      dimension x(nodes),A(nodes+1,nodes+1),B(nodes+1,nodes)
!      COMMON /MATRIX/ A(26,26),B(26,25)
      call SETB(nodes,X,nodes,A,B)
! xx where card should be calculated
!      y=card(xx,nonodes,x,nonodes)
      end
      FUNCTION CARD(XX,J,X,N,A,B)
      IMPLICIT REAL*8(a-H,O-Z)
!C      PARAMETER ( NY1=20, NY=NY1+5, NYY=NY ,NYY1=NYY+1)
      DIMENSION X(1),A(N+1,N+1),B(N+1,N)
!      COMMON /MATRIX/ A(N+1,N+1),B(N+1,N)
      CARD=B(1,J)+XX*B(2,J)
      DO 1 I=1,N
      IF (XX.LE.X(I)) RETURN
1     CARD=CARD+(XX-X(I))**3*B(I+2,J)
      RETURN
      ENTRY CARDD(XX,J,X,N,A,B)
      CARD=B(2,J)
      DO 2 I=1,N
      IF (XX.LE.X(I)) RETURN
2     CARD=CARD+3.*B(I+2,J)*(XX-X(I))**2
      CARDD=CARD
      RETURN
      END
      SUBROUTINE SETB(J,X,N,A,B)
      IMPLICIT REAL*8(A-H,O-Z)
!C     PARAMETER ( NY1=20, NY=NY1+5, NYY=NY ,NYY1=NYY+1)
      DIMENSION X(1),A(N+1,N+1),B(N+1,N)
!      COMMON /MATRIX/ A(26,26),B(26,25)
      L=N+1
      DO 1 I=1,L
      DO 2 M=1,L
      A(I,M)=0.0
      IF(M.NE.L) B(I,M)=0.0
2     CONTINUE
1     CONTINUE
!C      CALL PRESET(A,L*L,0.) DEFINITION SEE IN DOC. PAGE 10.
!C      CALL PRESET(B,L*N,0.)
      KK=J+1
      DO 3 I=1,J
      A(I,1)=1.0
      B(I,I)=1.0
      A(I,2)=X(I)
      IF (I.EQ.1) GO TO 3
      DO 4 K=2,I
4     A(I,K+1)=(X(I)-X(K-1))**3
      A(KK,I+1)=X(J)-X(I-1)
3     CONTINUE
      CALL SOLVEQN(A,B,KK,J,1,L,L)
      RETURN
      END
      SUBROUTINE SOLVEQN(A,B,N,NR,M,NRA,NRB)
      IMPLICIT REAL*8(A-H,O-Z)
	  real*8 a,b
      DIMENSION A(NRA,N),B(NRB,NR)
      IF (M.EQ.0) THEN
         DO 1 J=1,NR
         DO 1 I=1,N
 1       B(I,J)=0
         DO 2 I=1,MIN(N,NR)
 2       B(I,I)=1
      ELSE
         NN=N-1
      END IF
      IF (N.EQ.1) GO TO 300
      DO 100 I=1,NN
      TERM=ABS(A(I,I))
      II1=I+1
      K=I
      DO 110 J=II1,N
        IF (ABS(A(J,I)).LE.TERM) GO TO 110
        TERM=ABS(A(J,I))
        K=J
  110   CONTINUE
      IF (TERM.EQ.0.0) GO TO 500
      DO 120 J=I,N
        TERM=A(K,J)
        A(K,J)=A(I,J)
  120   A(I,J)=TERM
      DO 150 J=1,NR
        TERM=B(K,J)
        B(K,J)=B(I,J)
  150        B(I,J)=TERM
      DO 100 J=II1,N
        RM=-A(J,I)/A(I,I)
        DO 140 K=II1,N
  140        A(J,K)=A(J,K)+RM*A(I,K)
        DO 160 K=1,NR
  160        B(J,K)=B(J,K)+RM*B(I,K)
  100 CONTINUE
  300 DO 250 K=1,NR
      NEGN1=-(N-1)
      NEG1=-1
      B(N,K)=B(N,K)/A(N,N)
      IF (N.EQ.1) GO TO 250
      DO 200 II=NEGN1,NEG1
        I=-II
        II1=I+1
        DO 210 J=II1,N
  210        B(I,K)=B(I,K)-A(I,J)*B(J,K)
  200   B(I,K)=B(I,K)/A(I,I)
  250 CONTINUE
      GO TO 1000
  500 WRITE(6,501)
  501 FORMAT (22H SOLVE EQUATIONS FAILS)
 1000 RETURN
      END

