      use lin_sol_self_int 
type levels
sequence
real e(600),l(600),aparm(20),bparm(20)
integer nolev,a,z,noref,nofirst,nolast,nofold(20),nolold(20)
character*4 uncertaint
end type levels
!type init
!integer a,z,a0,u0,nofirst,nolast
!end type init
type(levels) all0(1500)
integer i,j,l,k,m,a,z,nolev,noref,levno,nonuc,mina,maxa,jj,nofit,sumdif(20)
character uncertaint*4,mytext*8
logical uncer,isend,even,badshape
integer, parameter :: nodes=20
integer, parameter :: minnolev=30
real*8 s,p,d,rm(nodes,nodes),s1(nodes),s2(nodes),p1,d1,card,bm,dbm,da,dt
real e,myx(250),myy(250),dmyy(250),dmyy1(250)
real*8 amat(nodes+1,nodes+1),xx,cm(nodes,nodes),dm(nodes,nodes)
real*8 bmat(nodes+1,nodes),xnodes(nodes),beta(nodes),Q(1500),w,qsum,difnofirst,difnolast,de0,dtde0,aparm
real*4 astab,zstab,massdef,tt
integer astable(0:150),zstable(0:150), nostable
character text*30
!COMMON /MATRIX/ AMAT,BMAT
!*************************************
!End of declarations
mina=300;maxa=1;nofit=0
open(1,file='levdens.dat',status='old')
open(2,file='par30_20_-4_4.dat',status='unknown')
open(3,file='err.dat',status='unknown')
open(4,file='stable1.txt',status='unknown')
read(4,*)
do while(.not.eof(4))
read(4,*) astab,zstab,text,massdef
nostable=zstab
!write(*,*) astab,zstab,massdef,nostable
astable(nostable)=astab
zstable(nostable)=zstab
enddo
close(4)
2 read(1,'(4i4)',end=1) a,z,nolev,noref
!write(3,*) a,z,nolev
!if(nolev.le.50.or..not.(even(z).and.even(a-z))) then
if(abs(a-astable(z)).le.4.and.nolev.ge.minnolev) then
	nonuc=nonuc+1
	uncer=.false.;badshape=.false.
	all0(nonuc)%a=a;all0(nonuc)%z=z;all0(nonuc)%nolev=nolev;all0(nonuc)%noref=noref
	mina=min(mina,a);maxa=max(maxa,a)
	do i=1,nolev
	read(1,'(e13.6,1x,i4,1x,a4)') e,levno,uncertaint
	all0(nonuc)%e(levno)=e*0.001;all0(nonuc)%l(i)=alog(float(i))
!	if(uncertaint.ne.'    '.and.e.eq.0.0) uncer=.true. !.and.(mod(a,2).eq.1.or.mod(z,2).eq.1)
	if(uncertaint.ne.'    ') uncer=.true. !.and.(mod(a,2).eq.1.or.mod(z,2).eq.1)
	enddo
	if(uncer) then
	write(3,*) a,z,nolev,nonuc
		nonuc=nonuc-1
	endif
!do i=nolev,3,-1
!tt=(all0(nonuc)%e(i)-all0(nonuc)%e(2))/(all0(nonuc)%l(i)-all0(nonuc)%l(2))
!if(tt.gt.3.0.and.i.lt.minnolev) badshape=.true.
!enddo
!if(badshape) nonuc=nonuc-1
else
	do i=1,nolev
	read(1,*)
	enddo
endif
goto 2
1 continue
!C PRefit
write(*,*) nonuc
do i=1,nonuc
call fit(all0(i)%nolev,all0(i)%e,all0(i)%a,all0(i)%z,all0(i)%nofirst,all0(i)%nolast)
all0(i)%nofold(1)=all0(i)%nofirst;all0(i)%nolold(1)=all0(i)%nolast
enddo
! End of prefit
!do i=10,250,10
!xnodes(i/10)=i
!enddo
do i=0,nodes-1
xnodes(i+1)=dble(mina)+dble(maxa-mina)*1.02/dble(nodes-1)*dble(i)
enddo
call initcardinal(nodes,xnodes,AMAT,BMAT)
!write(*,*) nonuc
!read(*,*)
!stop
!stop
!Start fitting
isend=.false.
3 nofit=nofit+1
if(nofit.gt.10) isend=.TRUE.
qsum=0.;difnofirst=0.;difnolast=0.
if(nofit.gt.1) then
call adjust(all0,nonuc,nofit)
endif
do k=1,nodes
	s1(k)=0.
		do m=1,nonuc
				s=0.;p=0.;d=0.
			do i=all0(m)%nofirst,all0(m)%nolast
				s=s+all0(m)%l(i)
				p=p+all0(m)%l(i)/all0(m)%e(i)
				d=d+1./all0(m)%e(i)
			enddo
			xx=all0(m)%a
		s1(k)=s1(k)+(s-p/d*dble(all0(m)%nolast-all0(m)%nofirst+1))*card(xx,k,xnodes,nodes,AMAT,BMAT)*xx
		enddo
enddo
do k=1,nodes
	do l=1,nodes
		s=0.;p=0.;rm(k,l)=0.
		do m=1,nonuc
			d=0.;d1=0.
				do i=all0(m)%nofirst,all0(m)%nolast
					d=d+1./all0(m)%e(i)
					d1=d1+all0(m)%e(i)
				enddo
				xx=all0(m)%a
				p=card(xx,k,xnodes,nodes,AMAT,BMAT)*card(xx,l,xnodes,nodes,AMAT,BMAT)*xx*xx
				s=d1-dble(all0(m)%nolast-all0(m)%nofirst+1)**2/d
 				rm(k,l)=rm(k,l)+p*s
		enddo
	enddo
enddo
do k=1,nodes
do i=1,nodes
cm(k,i)=0.
enddo
cm(k,k)=1.
enddo
!write(*,*) 'At 1'
!read(*,*)
call lin_sol_self(rm, cm, dm) 
!write(*,*) 'At 2'
!read(*,*)
!cm=matmul(rm, dm)
beta=matmul(dm,s1)
!do k=1,nodes
!write(*,'(9(e11.4,1x),2x,e11.4)') (cm(k,l),l=1,nodes),beta(k)
!enddo
!read(*,*)
do i=1,maxa-mina+1
myx(i)=i+mina-1;xx=myx(i);myy(i)=0.
do j=1,nodes
!myy(i)=myy(i)+beta(j)*card(xx,j,xnodes,nodes,AMAT,BMAT)
s1(j)=card(xx,j,xnodes,nodes,AMAT,BMAT)
enddo
s2=matmul(dm,s1)
myy(i)=dot_product(beta,s1)
myy(i)=1./(myy(i)*xx) !temperature T
w=sqrt(dot_product(s2,s1)) !Error of cardinal spline
dmyy(i)=w*myy(i)**2*xx !Uncertainty of temperature T
dmyy1(i)=-dmyy(i)
dmyy(i)=dmyy(i)+myy(i)
dmyy1(i)=dmyy1(i)+myy(i)
enddo

Call PGBEGIN(0,'/ms',1,1)
call pgvstand
      call pgwindow(0.,250.0,0.0,4.0)
	  call pgbox('bcnst',0.0,0,'bcnst',0.0,0)
call pglabel('(x)','(y)','Cubic spline')
	  call pgline(maxa-mina+1,myx,myy)
	  call pgline(maxa-mina+1,myx,dmyy)
	  call pgline(maxa-mina+1,myx,dmyy1)
write(*,*) nonuc
read(*,*)
qsum=0.;difnofirst=0.;difnolast=0.
do m=1,nonuc
d1=0.;xx=all0(m)%a;q(m)=0.
	do l=1,nodes
	s1(l)=card(xx,l,xnodes,nodes,AMAT,BMAT)
	d1=d1+beta(l)*s1(l)
	enddo
s2=matmul(dm,s1)
w=sqrt(dot_product(s2,s1)) !Error of cardinal spline
all0(m)%aparm(nofit)=d1*xx
aparm=d1*xx;s=dble(all0(m)%nolast-all0(m)%nofirst+1)
d=0.;p=0.
	do i=all0(m)%nofirst,all0(m)%nolast
	p=p+all0(m)%l(i)/all0(m)%e(i)
	d=d+1./all0(m)%e(i)
!	q(m)=q(m)+(all0(m)%l(i)-d1*all0(m)%e(i)-bm)**2/all0(m)%e(i)
	enddo
bm=(p-aparm*s)/d !param U0/T
!dbm=(dmyy(all0(m)%a-mina+1)-myy(all0(m)%a-mina+1))*d1*dble(all0(m)%nolast-all0(m)%nofirst+1)/d/myy(all0(m)%a-mina+1)**2
da=w*xx;dbm=-s/d*da
de0=-dbm/aparm+bm*da/(aparm**2);dt=-da/aparm**2
dtde0=dt*de0;de0=dsqrt(de0**2);dt=dsqrt(dt**2)
all0(m)%bparm(nofit)=bm
	do i=all0(m)%nofirst,all0(m)%nolast
	q(m)=q(m)+(all0(m)%l(i)-aparm*all0(m)%e(i)-bm)**2/all0(m)%e(i)
qsum=qsum+sqrt(q(m))/s

	enddo
if(isend) then
write(2,'(4i4,6(1x,f9.5),2i4)') m,all0(m)%a,all0(m)%z,int(xx-all0(m)%z), &
1./aparm,dt, -bm/aparm,de0,dtde0,&
sqrt(q(m))/s,all0(m)%nolast,all0(m)%nofirst
endif
if(nofit.gt.1) then
difnofirst=difnofirst+all0(m)%nofold(nofit-1)-all0(m)%nofirst
difnolast=difnolast+all0(m)%nolold(nofit-1)-all0(m)%nolast
endif
enddo
write(*,'(i3,f12.3,2f8.0)') nofit,qsum,difnofirst,difnolast

read(*,*)
call pgend
if(isend) goto 4
goto 3
4 write(*,*) 'Normal stop, Hit return to finish'
read(*,*)
stop
end
logical function even(i)
integer i
real*4 x
x=i
even=.false.
if(x/2.-float(int(x/2.+.1)).lt.0.1)  even=.true.
end

